=== debian/changelog ===
vg (1.22.0+ds-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 26 Feb 2020 15:08:37 +0100

vg (1.21.0+ds2-4) unstable; urgency=medium

  * Try without gperftools
  * autopkgtests: skip if the vg or libvcflib-tools package is not avialable
  * vg-docs: mark Multi-Arch: foreign
  * Standards-Version: 4.5.0 (routine-update)
  * Drop unnecessary dependency on dh-autoreconf.
  * Put vg-docs package in the "doc" section

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 15 Feb 2020 09:42:27 +0100

vg (1.21.0+ds2-3) unstable; urgency=medium

  * Only run the tests on arch dependent builds

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 12 Feb 2020 18:14:18 +0100

vg (1.21.0+ds2-2) unstable; urgency=medium

  * Converted build scripts to Python3.
  * Added support for other architectures using the SIMD Everywhere library.
  * Improve the nocheck build profile

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 12 Feb 2020 12:38:00 +0100

vg (1.21.0+ds2-1) unstable; urgency=medium

  * Initial release. (Closes: #939537)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 13 Jan 2020 11:32:02 +0100
