=== debian/watch ===
version=4
opts="repacksuffix=+ds,dversionmangle=auto,repack,compression=xz" \
https://github.com/vgteam/vg/releases .*/download/v\d[\-+\.:\~\da-zA-Z]*/vg-v@ANY_VERSION@@ARCHIVE_EXT@
